Package: geb.download

## [Groovy] Class DefaultDownloadSupport

- geb.download.DefaultDownloadSupport

- All Implemented Interfaces and Traits:
    DownloadSupport

      class DefaultDownloadSupport
      extends Object

  Provides methods to directly download content into the running program using HttpURLConnection.

  Any cookies that the browser currently has will be automatically transferred to the url connection, allowing it to assume the context of the browser.

  An instance of this class will be mixed in to all browser, page and module objects making these methods public methods on those objects.

- - ### Constructor Summary

    Constructors
    Constructor and description
    `DefaultDownloadSupport (Browser browser)`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `HttpURLConnection` | `download(Map options = [:])` Creates a http url connection to a url, that has the same cookies as the browser.
    `HttpURLConnection` | `download(String uri)`
    `byte[]` | `downloadBytes(Map options = [:], Closure connectionConfig = null)` Opens a url connection via download(Map) and returns the raw bytes.
    `byte[]` | `downloadBytes(Closure connectionConfig)`
    `byte[]` | `downloadBytes(String uri, Closure connectionConfig = null)` Opens a url connection via download(String) and returns the raw bytes.
    `Object` | `downloadContent(Map options = [:], Closure connectionConfig = null)` Opens a url connection via download(Map) and returns the content object.
    `Object` | `downloadContent(String uri, Closure connectionConfig = null)` Opens a url connection via download(String) and returns the content object.
    `Object` | `downloadContent(Closure connectionConfig)`
    `InputStream` | `downloadStream(Map options = [:], Closure connectionConfig = null)` Opens a url connection via download(Map) and returns the response input stream.
    `InputStream` | `downloadStream(String uri, Closure connectionConfig = null)` Opens a url connection via download(String) and returns the response input stream.
    `InputStream` | `downloadStream(Closure connectionConfig)`
    `String` | `downloadText(Map options = [:], Closure connectionConfig = null)` Opens a url connection via download(Map) and returns the response text, if the content type was textual.
    `String` | `downloadText(String uri, Closure connectionConfig = null)` Opens a url connection via download(String) and returns the response text, if the content type was textual.
    `String` | `downloadText(Closure connectionConfig)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Constructor Detail

    - #### DefaultDownloadSupport(Browser browser)

  - ### Method Detail

    - #### HttpURLConnection download(Map options = [:])

      Creates a http url connection to a url, that has the same cookies as the browser.

      Valid options are:

      - `uri` - optional - the uri to resolve relative to the base option (current browser page used if `null`)
      - `base` - optional - what to resolve the uri against (current browser page used if `null`)

    - #### HttpURLConnection download(String uri)

    - #### byte[] downloadBytes(Map options = [:], Closure connectionConfig = null)

      Opens a url connection via download(Map) and returns the raw bytes.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

    - #### byte[] downloadBytes(Closure connectionConfig)

    - #### byte[] downloadBytes(String uri, Closure connectionConfig = null)

      Opens a url connection via download(String) and returns the raw bytes.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

    - #### Object downloadContent(Map options = [:], Closure connectionConfig = null)

      Opens a url connection via download(Map) and returns the content object.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

      See Also:
        URLConnection.getContent

    - #### Object downloadContent(String uri, Closure connectionConfig = null)

      Opens a url connection via download(String) and returns the content object.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

      See Also:
        URLConnection.getContent

    - #### Object downloadContent(Closure connectionConfig)

    - #### InputStream downloadStream(Map options = [:], Closure connectionConfig = null)

      Opens a url connection via download(Map) and returns the response input stream.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

    - #### InputStream downloadStream(String uri, Closure connectionConfig = null)

      Opens a url connection via download(String) and returns the response input stream.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

    - #### InputStream downloadStream(Closure connectionConfig)

    - #### String downloadText(Map options = [:], Closure connectionConfig = null)

      Opens a url connection via download(Map) and returns the response text, if the content type was textual.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

    - #### String downloadText(String uri, Closure connectionConfig = null)

      Opens a url connection via download(String) and returns the response text, if the content type was textual.

      If connectionConfig is given, it is called with the HttpURLConnection before the request is made.

    - #### String downloadText(Closure connectionConfig)